/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */
import type { CreateRunnerTeam } from '../models/CreateRunnerTeam';
import type { ResponseEmpty } from '../models/ResponseEmpty';
import type { ResponseRunnerTeam } from '../models/ResponseRunnerTeam';
import type { UpdateRunnerTeam } from '../models/UpdateRunnerTeam';
import { request as __request } from '../core/request';

export class RunnerTeamService {

    /**
     * Get all
     * Lists all runnerTeams.
     * @result ResponseRunnerTeam
     * @throws ApiError
     */
    public static async runnerTeamControllerGetAll(): Promise<Array<ResponseRunnerTeam>> {
        const result = await __request({
            method: 'GET',
            path: `/api/teams`,
        });
        return result.body;
    }

    /**
     * Post
     * Create a new runnerTeam object (id will be generated automagicly).
     * @param requestBody CreateRunnerTeam
     * @result ResponseRunnerTeam
     * @throws ApiError
     */
    public static async runnerTeamControllerPost(
        requestBody?: CreateRunnerTeam,
    ): Promise<ResponseRunnerTeam> {
        const result = await __request({
            method: 'POST',
            path: `/api/teams`,
            body: requestBody,
        });
        return result.body;
    }

    /**
     * Get one
     * Returns a runnerTeam of a specified id (if it exists)
     * @param id
     * @result ResponseRunnerTeam
     * @throws ApiError
     */
    public static async runnerTeamControllerGetOne(
        id: number,
    ): Promise<ResponseRunnerTeam> {
        const result = await __request({
            method: 'GET',
            path: `/api/teams/${id}`,
        });
        return result.body;
    }

    /**
     * Put
     * Update a runnerTeam object (id can't be changed).
     * @param id
     * @param requestBody UpdateRunnerTeam
     * @result ResponseRunnerTeam
     * @throws ApiError
     */
    public static async runnerTeamControllerPut(
        id: number,
        requestBody?: UpdateRunnerTeam,
    ): Promise<ResponseRunnerTeam> {
        const result = await __request({
            method: 'PUT',
            path: `/api/teams/${id}`,
            body: requestBody,
        });
        return result.body;
    }

    /**
     * Remove
     * Delete a specified runnerTeam (if it exists).
     * @param id
     * @param force
     * @result ResponseRunnerTeam
     * @result ResponseEmpty
     * @throws ApiError
     */
    public static async runnerTeamControllerRemove(
        id: number,
        force?: boolean,
    ): Promise<ResponseRunnerTeam | ResponseEmpty> {
        const result = await __request({
            method: 'DELETE',
            path: `/api/teams/${id}`,
            query: {
                'force': force,
            },
        });
        return result.body;
    }

}